%define runuser toruser

Name:		tor
Version:	0.2.2.39
%define subrel	1
Release:	%mkrel 2
Summary:	Anonymizing overlay network for TCP (The onion router)
URL:		http://www.torproject.org/
Group:		Networking/Other
License:	BSD-like
Requires(post):  systemd
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1
Requires(post):   sysvinit
Requires(preun):  sysvinit
Requires(postun): sysvinit
Requires:	openssl >= 0.9.6
Requires:	tsocks
BuildRequires:	openssl-devel >= 0.9.6 
BuildRequires:	libevent-devel
BuildRequires:	zlib-devel
BuildRequires:	autoconf2.5
BuildRequires:	transfig, tetex-latex
BuildRequires:	ghostscript
Source0:	http://www.torproject.org/dist/%{name}-%{version}.tar.gz
Source1:	%{name}.logrotate
Source2:	%{name}.init
Source3: 	%{name}.sysconfig
Source4:	%{name}.service
Source5:	%{name}-tmpfiles.conf
Patch0:		tor-0.2.2.39-SENDME-DOS.patch

%description
Tor is a connection-based low-latency anonymous communication system.

This package provides the "tor" program, which serves as both a client and
a relay node. Scripts will automatically create a "%{runuser}" user and
group, and set tor up to run as a daemon when the system is rebooted.

Applications connect to the local Tor proxy using the SOCKS
protocol. The local proxy chooses a path through a set of relays, in
which each relay knows its predecessor and successor, but no
others. Traffic flowing down the circuit is unwrapped by a symmetric
key at each relay, which reveals the downstream relay.

Warnings: Tor does no protocol cleaning.  That means there is a danger
that application protocols and associated programs can be induced to
reveal information about the initiator. Tor depends on Privoxy and
similar protocol cleaners to solve this problem. This is alpha code,
and is even more likely than released code to have anonymity-spoiling
bugs. The present network is very small -- this further reduces the
strength of the anonymity provided. Tor is not presently suitable
for high-stakes anonymity.

%prep
%setup -q 
%patch0 -p1
 
%build
%configure2_5x
%make

%install
%makeinstall

%define _logdir %{_var}/log

mkdir -p ${RPM_BUILD_ROOT}%{_initrddir}
cat %{SOURCE2} > ${RPM_BUILD_ROOT}%{_initrddir}/%{name}
chmod 0755 ${RPM_BUILD_ROOT}%{_initrddir}/%{name}

install -p -m 644 ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/torrc.sample ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/torrc

mkdir -p -m 755 ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
cat %{SOURCE1} > ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}

mkdir -p -m 755 ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/
cat %{SOURCE3} > ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}

mkdir -p -m 700 ${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name}
mkdir -p -m 755 ${RPM_BUILD_ROOT}%{_var}/%{name}
mkdir -p -m 755 ${RPM_BUILD_ROOT}%{_logdir}/%{name}

# Bash completion
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/bash_completion.d
echo 'complete -F _command $filenames torify' > ${RPM_BUILD_ROOT}%{_sysconfdir}/bash_completion.d/%{name}

# Systemd support
install -D -p -m 0644 %SOURCE4 $RPM_BUILD_ROOT%_unitdir/%name.service
install -D -p -m 0644 %{SOURCE5} %{buildroot}%{_prefix}/lib/tmpfiles.d/%{name}.conf

%pre
%_pre_useradd %{runuser} / /bin/false

%post
systemd-tmpfiles --create
%_post_service %{name}

%preun
%_preun_service %{name}
rm -f %{_localstatedir}/%{name}/cached-directory
rm -f %{_localstatedir}/%{name}/bw_accounting
rm -f %{_localstatedir}/%{name}/control_auth_cookie
rm -f %{_localstatedir}/%{name}/router.desc
rm -f %{_localstatedir}/%{name}/fingerprint

%postun
%_postun_userdel %{runuser}
%_postun_groupdel %{runuser}

%files
%doc ReleaseNotes INSTALL LICENSE README ChangeLog doc/HACKING doc/TODO
%{_mandir}/man*/*
%{_bindir}/tor
%{_bindir}/torify
%{_bindir}/tor-resolve
%{_bindir}/tor-gencert
%config(noreplace) %attr(0755,%{runuser},%{runuser}) %{_initrddir}/%{name}
%_unitdir/%name.service
%{_prefix}/lib/tmpfiles.d/%{name}.conf
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/logrotate.d/%{name}
%dir %attr(0755,root,%{runuser}) %{_sysconfdir}/%{name}/
%config(noreplace) %attr(0644,root,%{runuser}) %{_sysconfdir}/%{name}/*
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%attr(0700,%{runuser},%{runuser}) %dir %{_localstatedir}/lib/%{name}
%attr(0750,%{runuser},%{runuser}) %dir %{_var}/%{name}
%attr(0750,%{runuser},%{runuser}) %dir %{_logdir}/%{name}
%{_sysconfdir}/bash_completion.d/%{name}
%{_datadir}/%{name}


%changelog

* Fri Dec 07 2012 luigiwalser <luigiwalser> 0.2.2.39-2.1.mga2
+ Revision: 327870
- add upstream patch to fix CVE-2012-5573

  + kharec <kharec>
    - no subrel needed
    - Backport tor-0.2.2.39-1 for a CVS fix (#5351)

  + colin <colin>
    - Fix tmpfiles usage on older systemd
    - Fix tor systemd unit (mga#6843)
    - Use tmpfiles for pid dir
    - Add systemd require for %%post script

  + tmb <tmb>
    - Require rpm-helper >= 0.24.8-1 for systemd support

* Sat Apr 21 2012 colin <colin> 0.2.2.35-4.mga2
+ Revision: 232395
- Tidy up systemd unit.

* Mon Jan 23 2012 dmorgan <dmorgan> 0.2.2.35-3.mga2
+ Revision: 200138
- Own %%{_var}/%%{name}

* Sun Jan 15 2012 dmorgan <dmorgan> 0.2.2.35-2.mga2
+ Revision: 196574
- Add systemd support ( from fedora)

* Sat Dec 17 2011 kharec <kharec> 0.2.2.35-1.mga2
+ Revision: 183206
- new version 0.2.2.35

* Fri Sep 23 2011 boklm <boklm> 0.2.2.33-1.mga2
+ Revision: 147145
- update to version 0.2.2.33

  + fwang <fwang>
    - new version 0.2.2.32

* Thu Mar 17 2011 boklm <boklm> 0.2.1.30-1.mga1
+ Revision: 73394
- imported package tor

